"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InsightsChip = void 0;
const react_1 = __importDefault(require("react"));
const leafygreen_1 = require("./leafygreen");
const emotion_1 = require("@leafygreen-ui/emotion");
const tokens_1 = require("@leafygreen-ui/tokens");
const palette_1 = require("@leafygreen-ui/palette");
const use_theme_1 = require("../hooks/use-theme");
const chipLightModeStyles = (0, emotion_1.css)({
    '--chipBackgroundColor': palette_1.palette.blue.light3,
    '--chipBorderColor': palette_1.palette.blue.light2,
    '--chipColor': palette_1.palette.blue.dark1,
});
const chipDarkModeStyles = (0, emotion_1.css)({
    '--chipBackgroundColor': palette_1.palette.blue.dark2,
    '--chipBorderColor': palette_1.palette.blue.dark1,
    '--chipColor': palette_1.palette.blue.light2,
});
const chipStyles = (0, emotion_1.css)({
    fontWeight: tokens_1.fontWeights.bold,
    textTransform: 'uppercase',
    color: 'var(--chipColor)',
    backgroundColor: 'var(--chipBackgroundColor)',
});
const InsightsChip = () => {
    const isDarkMode = (0, use_theme_1.useDarkMode)();
    return (react_1.default.createElement(leafygreen_1.Chip, { className: (0, emotion_1.cx)(isDarkMode
            ? [chipDarkModeStyles, chipStyles]
            : [chipLightModeStyles, chipStyles]), label: "insight", glyph: react_1.default.createElement(leafygreen_1.Icon, { glyph: "Bulb" }) }));
};
exports.InsightsChip = InsightsChip;
//# sourceMappingURL=insights-chip.js.map