"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectList = void 0;
const react_1 = __importStar(require("react"));
const leafygreen_1 = require("./leafygreen");
const tokens_1 = require("@leafygreen-ui/tokens");
const emotion_1 = require("@leafygreen-ui/emotion");
const palette_1 = require("@leafygreen-ui/palette");
const use_theme_1 = require("../hooks/use-theme");
const checkboxStyles = (0, emotion_1.css)({
    padding: tokens_1.spacing[100],
});
const containerStyles = (0, emotion_1.css)({
    display: 'flex',
    flexDirection: 'column',
});
const evenRowStylesDark = (0, emotion_1.css)({ backgroundColor: palette_1.palette.gray.dark3 });
const evenRowStylesLight = (0, emotion_1.css)({ backgroundColor: palette_1.palette.gray.light3 });
const listHeaderStyles = (0, emotion_1.css)({
    display: 'flex',
    alignItems: 'center',
    fontWeight: 600,
    borderBottom: `${tokens_1.spacing[100]}px solid ${palette_1.palette.gray.light2}`,
    flexShrink: 0,
    padding: `${tokens_1.spacing[100]}px 0px`,
});
const listBodyStyles = (0, emotion_1.css)({
    overflow: 'auto',
});
const listItemStyles = (0, emotion_1.css)({
    padding: `${tokens_1.spacing[100]}px 0px`,
});
const selectAllLabelStyles = (0, emotion_1.css)({ lineHeight: '16px' });
function SelectList(props) {
    const { items, label, disabled, onChange } = props;
    const isDarkMode = (0, use_theme_1.useDarkMode)();
    const evenRowStyles = isDarkMode ? evenRowStylesDark : evenRowStylesLight;
    const selectAll = items.every((item) => item.selected);
    const selectNone = items.every((item) => !item.selected);
    const handleSelectAllChange = (0, react_1.useCallback)((e) => {
        onChange(items.map((item) => ({ ...item, selected: !!e.target.checked })));
    }, [items, onChange]);
    const handleSelectItemChange = (0, react_1.useCallback)((e) => {
        onChange(items.map((item) => e.target.name === `select-${item.id}`
            ? { ...item, selected: !!e.target.checked }
            : item));
    }, [items, onChange]);
    return (react_1.default.createElement("div", { className: (0, emotion_1.cx)(props.className, containerStyles) },
        react_1.default.createElement("div", { className: listHeaderStyles },
            react_1.default.createElement(leafygreen_1.Checkbox, { className: (0, emotion_1.cx)(checkboxStyles, (0, emotion_1.css)({ paddingRight: 0 })), "data-testid": "select-list-all-checkbox", "aria-label": "Select all", onChange: handleSelectAllChange, checked: selectAll, indeterminate: !selectAll && !selectNone, disabled: disabled }),
            react_1.default.createElement("div", { className: selectAllLabelStyles }, label.name)),
        react_1.default.createElement("div", { className: listBodyStyles }, items.map((item, index) => (react_1.default.createElement("div", { className: (0, emotion_1.cx)(listItemStyles, index % 2 === 0 && evenRowStyles), key: `select-list-item-${item.id}`, "data-testid": `select-list-item-${item.id}` },
            react_1.default.createElement(leafygreen_1.Checkbox, { className: checkboxStyles, key: `select-${item.id}`, name: `select-${item.id}`, "data-testid": `select-${item.id}`, label: item[label.displayLabelKey], "aria-label": item[label.ariaLabelKey ?? label.displayLabelKey], onChange: handleSelectItemChange, checked: item.selected, disabled: disabled })))))));
}
exports.SelectList = SelectList;
//# sourceMappingURL=select-list.js.map